# Echo server program
import socket
import time
import sys
import er2sim as er2

HOST = '127.0.0.1'             # Symbolic name meaning the local host
HOST = '169.254.87.131'        # Symbolic name meaning the local host
PORT = 5008              # Arbitrary non-privileged port
PORT = 5050              # Arbitrary non-privileged port
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.bind((HOST, PORT))
#s.setblocking(0)
s.settimeout(0.1)
s.listen(1)

accepted = False
count = 0
conn = None

# create ER2 and ABS objects
robot =  er2.ER2(PORT=0, mapfile="mapSquare.txt")
print robot.GetOdometry()
abs = None

def handleData( data ):
    print 'data is ', data
    # make sure we have a string...
    if type(data) == type('s'):
        # parse data
        listdata = data.strip().split('_')  # no lowercase...

        print 'listdata is', listdata
        if len(listdata) > 0:
            message = listdata[0]

            if message == 'GetOdometry':
                o = robot.GetOdometry()
                reply = '%.3f_%.3f_%.3f' % (o[0], o[1], o[2])
                #print 'o is', o
                #print 'reply is', reply
                return reply
            else:
                return message


        else:
            return data
    else:
        return 'hi 42'


try:   # catch keyboard exceptions to close objects safely

    # listen for connections...
    while True:
    
        # reset ER2 and ABS objects to safe, steady states
        robot.Go( 0.0, 0.0 ) # just to test
    
        print 'Listening...'
    
        while True:
            try:
                conn, addr = s.accept()
                print 'Connected to', addr, 'at count', count
                break
            except socket.error:
                count += 1
                time.sleep(0.1)

        # now, we begin the loop
        robot.Go( 10.0, 0.0 ) # just to test
        
        while True:
            try:
                data = conn.recv(1024)
                if len(data) < 1: break # breaks if the connection is broken
                if data[0] == 'q': break
    
                # here is where the data is handled
                reply = handleData( data )
                conn.send(reply)   # send back the desired reply
    
            except:
                # no data received... 
                time.sleep(0.01)
    
        conn.close()

except KeyboardInterrupt:

    print 'Keyboard Interrupt... closing robots'

    # close robot objects gracefully and exit
    robot.CloseRobot()

if conn != None:
    conn.close()

